/*
 * circularBuffer.cpp
 *
 *  Created on: 07/11/2011
 *      Author: ccortiz
 */

#include "circularBuffer.h"

circularBuffer::circularBuffer() {

	clean();
}

circularBuffer::~circularBuffer() {

}

fifoStates circularBuffer::clean(){

	for (unsigned int i=0;i<_CIRCULAR_BUFFER_SIZE_*sizeof(_data);i++){
		*((unsigned char*)dataArray + i)=0;
	}

	nElements  = 0;
	indexRead  = 0;
	indexWrite = 0;
	mark       = 0;
	return _OK_;

}

fifoStates circularBuffer::push(_data newData){

	//Copiamos byte a byte los objetos.
	unsigned char* p1 = (unsigned char*)&dataArray[indexWrite];
	unsigned char* p2 = (unsigned char*)&newData;
	for (unsigned int i=0;i< sizeof(_data);i++){
		*(p1+i) = *(p2+i);
	}

	//dataArray[indexWrite]=newData;
	indexWrite=(indexWrite+1)%_CIRCULAR_BUFFER_SIZE_;

	if (nElements<_CIRCULAR_BUFFER_SIZE_)
	{
		nElements+=(nElements<_CIRCULAR_BUFFER_SIZE_);
	}
	else
	{
		indexRead=(indexRead+1)%_CIRCULAR_BUFFER_SIZE_;
		//cout << "   Avanzando puntero de lectura, pos "<<ptr_lectura<<endl<<flush;
	}

	if (nElements<_CIRCULAR_BUFFER_SIZE_){
		return _OK_;
	}

	return _OVERWRITTING_;
}

fifoStates circularBuffer::pop(_data* returnData){

	if (nElements>0)
	{
		*returnData = dataArray[indexRead];
		indexRead=(indexRead+1)%_CIRCULAR_BUFFER_SIZE_;
		nElements--;
		return _OK_;
	}

	return _EMPTY_;
}

unsigned int circularBuffer::getNumberOfElements(){
	return nElements;
}

//Experimental
void circularBuffer::setMark(){
	mark = indexRead;
}

void circularBuffer::gotoMark(unsigned int restoredBytes){
	indexRead = mark;
	nElements += restoredBytes;

}

