/*
 * mensaje1.c
 *
 *  Created on: 25/05/2012
 *      Author: ccortiz
 */


#include "mensaje1.h"
#include "default_ICD.h" 

#include <stdio.h>
#include <stdlib.h>

static byte_ptr serialize_Mensaje1(int ICD_Descriptor);
static int deserialize_Mensaje1(int ICD_Descriptor, byte_ptr dataBuffer,uint16 bufferSize, boolean decodeMessage);
static int get_MsgSize_Mensaje1(int ICD_Descriptor);
static int get_Mensaje1_Header_ID(int ICDDescriptor);
static int set_Mensaje1_Header_Repetitions_OPT(int ICD_Descriptor, unsigned int value, boolean useDeserializeCopy);
static int set_Mensaje1_Header_Repetitions(int ICD_Descriptor, unsigned int value);
static int get_Mensaje1_Header_Repetitions(int ICDDescriptor);
static int set_Mensaje1_Data_BlockSize_OPT(int ICD_Descriptor, unsigned int itemIndex, unsigned int value, boolean useDeserializeCopy);
static int set_Mensaje1_Data_BlockSize(int ICD_Descriptor, unsigned int itemIndex, unsigned int value);
static int get_Mensaje1_Data_BlockSize(int ICDDescriptor, unsigned int itemIndex);
static int set_Mensaje1_Data_Block(int ICD_Descriptor, unsigned int itemIndex, byte_ptr srcBuffer);
static int get_Mensaje1_Data_Block(int ICD_Descriptor, unsigned int itemIndex, byte_ptr destBuffer);


extern c_DEFAULT_ICD_Privates_Ptr ICD_Objs[_MAX_ICD_INSTANCES_];

void initialize_Mensaje1(int parentDescriptor, c_Mensaje1_Ptr classReference, c_Mensaje1_privates_Ptr privatesReference){
	
	int i=0;
	int j=0;

	/* Make methods Links. */
	
	
	classReference->get_ID = get_Mensaje1_Header_ID;
	
	classReference->set_Repetitions = set_Mensaje1_Header_Repetitions;
	classReference->get_Repetitions = get_Mensaje1_Header_Repetitions;
	
	classReference->set_BlockSize = set_Mensaje1_Data_BlockSize;
	classReference->get_BlockSize = get_Mensaje1_Data_BlockSize;
	
	classReference->set_Block = set_Mensaje1_Data_Block;
	classReference->get_Block = get_Mensaje1_Data_Block;
	
	classReference->serialize      = serialize_Mensaje1;
	classReference->deserialize    = deserialize_Mensaje1;
	classReference->set_Endianness = set_Endianness_Mensaje1;
	classReference->get_MsgSize    = get_MsgSize_Mensaje1;

	/* Clean attributes. */
	
	privatesReference->msgInfo.header.ID = 0;
	privatesReference->msgInfo.header.repetitions = 0;
			
	for (i=0; i<5; i++){
		privatesReference->msgInfo.data[i].blockSize = 0;
		for (j=0; j<16; j++){privatesReference->msgInfo.data[i].block[j] = 0;}
	}
		
	
	/* Make new instance of bitStack class. */
	privatesReference->bitStackerDescriptor = new_bitStack();

	if (privatesReference->bitStackerDescriptor == -1){
		_DBGMSG_("ERROR! CAN'T MAKE A NEW BITSTACK FOR 'Mensaje1'\n");
	}

	/* Configure default endianness. */
	setOutputEndianness(privatesReference->bitStackerDescriptor, _LITTLE_ENDIAN_);

	/* And make a first serialization to get the default message size. */
	serialize_Mensaje1(parentDescriptor);
}

byte_ptr serialize_Mensaje1(int ICD_Descriptor){

	int i = 0;
	int itemRepetitions = 0;
	int dataBlockSize = 0;	
	
	int j = 0;

	int stackerDescriptor = 0;
	c_Mensaje1_privates_Ptr privates = 0;
	byte_ptr returnedData = 0;

	if (ICD_Descriptor<0 || ICD_Descriptor >= _MAX_ICD_INSTANCES_){
		_DBGMSG_("ERROR!. Invalid descriptor in function 'serialize_Mensaje1'.\n");
		return 0;
	}

	if (ICD_Objs[ICD_Descriptor] == 0){
		_DBGMSG_("ERROR!. Uninitialized descriptor in function 'serialize_Mensaje1'.\n");
		return 0;
	}

	privates = &(ICD_Objs[ICD_Descriptor]->mensaje1_Privates);

	stackerDescriptor = privates->bitStackerDescriptor;

	clearStack(stackerDescriptor);

	stackData(stackerDescriptor, (unsigned char*)&(privates->msgInfo.header.ID), 16);
	stackData(stackerDescriptor, (unsigned char*)&(privates->msgInfo.header.repetitions), 16);
	
	itemRepetitions = privates->msgInfo.header.repetitions;

	if (itemRepetitions>5){
		_DBGMSG_("ERROR!. itemRepetitions > 5. Item 'data' Out of bound in function 'serialize_Mensaje1'!\n");
		return 0;	
	}

	for (i=0; i<itemRepetitions; i++){
		stackData(stackerDescriptor, (unsigned char*)&(privates->msgInfo.data[i].blockSize), 16);

		dataBlockSize = privates->msgInfo.data[i].blockSize;
		if (dataBlockSize>16){
			_DBGMSG_("ERROR!. daBlockSize > 16. Field 'block' Out of bound in function 'serialize_Mensaje1'!\n");
			return 0;
		}

		for(j=0; j<dataBlockSize; j++){ stackData(stackerDescriptor, (unsigned char*)&(privates->msgInfo.data[i].block[j]), 8);}
	} 

	
	returnedData = getDataBuffer(stackerDescriptor);

	/* Update message size. */
	privates->msgSize = get_MsgSize_Mensaje1( ICD_Descriptor );

	return returnedData;
}

int get_MsgSize_Mensaje1(int ICD_Descriptor){
	int stackerDescriptor = 0;
	c_Mensaje1_privates_Ptr privates = 0;

	if (ICD_Descriptor<0 || ICD_Descriptor >= _MAX_ICD_INSTANCES_){
		_DBGMSG_("ERROR!. Invalid descriptor in function 'get_MsgSize_Mensaje1'.\n");
		return -1;
	}

	if (ICD_Objs[ICD_Descriptor] == 0){
		_DBGMSG_("ERROR!. uninitialized descriptor in function 'get_MsgSize_Mensaje1'.\n");
		return -1;
	}

	privates = &ICD_Objs[ICD_Descriptor]->mensaje1_Privates;
	stackerDescriptor = privates->bitStackerDescriptor;

	return getStackSize(stackerDescriptor);
}


int deserialize_Mensaje1(int ICD_Descriptor, byte_ptr dataBuffer,uint16 bufferSize, boolean decodeMessage){
	int i=0;
	int itemRepetitions=0;
	int dataBlockSize = 0;
	int j=0;

	c_Mensaje1_privates_Ptr privates = 0;
	int stackerDescriptor = 0;

	boolean fixedLength = _TRUE_;
	fixedLength = _FALSE_;


	if (ICD_Descriptor<0 || ICD_Descriptor >= _MAX_ICD_INSTANCES_){
		_DBGMSG_("ERROR!. Invalid descriptor in function 'deserialize_Mensaje1'.\n");
		return _INVALID_DESCRIPTOR_;
	}

	if (ICD_Objs[ICD_Descriptor] == 0){
		_DBGMSG_("ERROR!. Uninitialized descriptor in function 'deserialize_Mensaje1'.\n");
		return _INVALID_DESCRIPTOR_;
	}

	privates = &ICD_Objs[ICD_Descriptor]->mensaje1_Privates;
	stackerDescriptor = privates->bitStackerDescriptor;

	/* Check message size. */
	if (privates->msgSize != bufferSize && fixedLength){
		_DBGMSG_("Incorrect Msg Size. NOT Mensaje1!\n");
		return _INCORRECT_MSG_SIZE_;
	}

	/* Load the buffer in bitStack. */
	clearStack(stackerDescriptor);
	
	if (setDataBuffer(stackerDescriptor, dataBuffer, bufferSize) < 0){
		_DBGMSG_("ERROR!. Can't set 'databuffer' because 'bufferSize' > _MAX_DATA_STACK_SIZE_.\n");
		return _INCORRECT_MSG_SIZE_;
	}
	
	privates->msgCheckInfo.header.ID = unstackData(stackerDescriptor, 16);
	if (privates->msgCheckInfo.header.ID != 0){
		_DBGMSG_("Constant field 'header.ID' out of range in deserialize_Mensaje1()!\n");
		return _INCORRECT_CONSTANT_FIELDS_;
	}	

	privates->msgCheckInfo.header.repetitions = unstackData(stackerDescriptor, 16);
	if (set_Mensaje1_Header_Repetitions_OPT(ICD_Descriptor, privates->msgCheckInfo.header.repetitions, _TRUE_) == setterError){
		_DBGMSG_("Field 'repetitions' out of range in deserialize_Mensaje1()!\n");
		return _FIELDS_OUT_OF_RANGE_;
	}

	
	itemRepetitions = privates->msgInfo.header.repetitions;

	if (itemRepetitions>5){
		_DBGMSG_("ERROR!. itemRepetitions > 5. Item 'data' Out of bound in function 'deserialize_Mensaje1'!\n");
		return _ITEM_OUT_OF_RANGE_;	
	}
	for (i=0; i<itemRepetitions; i++){
		privates->msgCheckInfo.data[i].blockSize = unstackData(stackerDescriptor, 16);
		if (set_Mensaje1_Data_BlockSize_OPT(ICD_Descriptor, i, privates->msgCheckInfo.data[i].blockSize, _TRUE_) == setterError){
			_DBGMSG_("Field 'blockSize' out of range in deserialize_Mensaje1()!\n");
			return _FIELDS_OUT_OF_RANGE_;
		}

		dataBlockSize = privates->msgInfo.data[i].blockSize;
		if (dataBlockSize>16){
			_DBGMSG_("ERROR!. daBlockSize > 16. Field 'block' Out of bound in function 'deserialize_Mensaje1'!\n");
			return _FIELDS_OUT_OF_RANGE_;
		}

		for (j=0; j<dataBlockSize; j++){ privates->msgCheckInfo.data[i].block[j] = unstackData(stackerDescriptor, 8); }	

	}


	_DBGMSG_("--- Mensaje1 FOUND! ---\n");
	if (decodeMessage){
		memcpy((char*)&privates->msgInfo, (char*)&privates->msgCheckInfo, sizeof(struct c_Mensaje1_data));
/*
		
		printf("\nID: %X", privates->msgInfo.header.ID);
		
		printf("\nrepetitions: %X", privates->msgInfo.header.repetitions);
		
		itemRepetitions = privates->msgInfo.header.repetitions;

		if (itemRepetitions>5){
			_DBGMSG_("ERROR!. itemRepetitions > 5. Item 'data' Out of bound!\n");
			return 0;	
		}
		
		for (i=0; i<itemRepetitions; i++){
		
			printf("\nblockSize[%d]: %X", i, privates->msgInfo.data[i].blockSize);
		
			dataBlockSize = privates->msgInfo.data[i].blockSize;
			if (dataBlockSize>16){
				_DBGMSG_("ERROR!. daBlockSize > 16. Field 'block' Out of bound in function 'serialize_Mensaje1'!\n");
				return 0;
			}

			printf("\nblock[%d]: ",i);
			for (j=0; j<dataBlockSize; j++){ printf("%.2X ", (uint32) (privates->msgInfo.data[i].block[j]) ); }
		}
*/
	}

	return _DESERIALIZE_OK_;

}

void set_Endianness_Mensaje1(int ICD_Descriptor, enum endianness endianType){
	c_Mensaje1_privates_Ptr privates= 0;
	int stackerDescriptor;

	if (ICD_Descriptor<0 || ICD_Descriptor >= _MAX_ICD_INSTANCES_){
		_DBGMSG_("ERROR!. Invalid descriptor in function 'set_Endianness_Mensaje1'.\n");
		return;
	}

	if (ICD_Objs[ICD_Descriptor] == 0){
		_DBGMSG_("ERROR!. Uninitialized descriptor in function 'set_Endianness_Mensaje1'.\n");
		return;
	}

/*
	printf("\nConfigurando Endianness para Mensaje1, descriptor %d: ", ICD_Descriptor);
	fflush(stdout);
*/

	privates = &ICD_Objs[ICD_Descriptor]->mensaje1_Privates;
	stackerDescriptor = privates->bitStackerDescriptor;

	setOutputEndianness(stackerDescriptor, endianType);
	clearStack(stackerDescriptor);
}

/* --- GETTERS & SETTERS --- */
int get_Mensaje1_Header_ID(int ICD_Descriptor){
	
	c_Mensaje1_privates_Ptr privates= 0;
	privates = &ICD_Objs[ICD_Descriptor]->mensaje1_Privates;
	
	if (ICD_Descriptor<0 || ICD_Descriptor >= _MAX_ICD_INSTANCES_){
		_DBGMSG_("ERROR!. Invalid descriptor  in function 'get_Mensaje1_Header_ID'.\n");
		return -1;
	}

	if (ICD_Objs[ICD_Descriptor] == 0){
		_DBGMSG_("ERROR!. Uninitialized descriptor in function 'get_Mensaje1_Header_ID'.\n");
		return -1;
	}

	
	return privates->msgInfo.header.ID;
}

int set_Mensaje1_Header_Repetitions_OPT(int ICD_Descriptor, unsigned int value, boolean useDeserializeCopy){
	c_Mensaje1_privates_Ptr privates= 0;
	privates = &ICD_Objs[ICD_Descriptor]->mensaje1_Privates;
	
	/*printf("Set_Mensaje1-Campo1. ICD_Descriptor=%d, value=%d, useDeserializeCopy=%d\n", ICD_Descriptor, value, useDeserializeCopy);*/

	if (ICD_Descriptor<0 || ICD_Descriptor >= _MAX_ICD_INSTANCES_){
		_DBGMSG_("ERROR!. Invalid descriptor  in function 'set_Mensaje1_Header_Repetitions_OPT'.\n");
		return setterError;
	}

	if (ICD_Objs[ICD_Descriptor] == 0){
		_DBGMSG_("ERROR!. Uninitialized descriptor in function 'set_Mensaje1_Header_Repetitions_OPT'.\n");
		return setterError;
	}


	if (value>=0 && value<=5){
		if (!useDeserializeCopy){
			privates->msgInfo.header.repetitions = value;
		}
		else{
			privates->msgCheckInfo.header.repetitions = value;
		}	
		return setterOK;
	}
	else{
		return setterError;
	}
}
			
int set_Mensaje1_Header_Repetitions(int ICD_Descriptor, unsigned int value){
	int returnState = 0;
	returnState = set_Mensaje1_Header_Repetitions_OPT(ICD_Descriptor, value, _FALSE_);
	if (returnState==setterError){
		_DBGMSG_("ERROR! Can't assign value in function 'set_Mensaje1_Header_Repetitions'.\n");
	}

	return returnState;
}
			
int get_Mensaje1_Header_Repetitions(int ICD_Descriptor){
	
	c_Mensaje1_privates_Ptr privates= 0;
	privates = &ICD_Objs[ICD_Descriptor]->mensaje1_Privates;
	
	if (ICD_Descriptor<0 || ICD_Descriptor >= _MAX_ICD_INSTANCES_){
		_DBGMSG_("ERROR!. Invalid descriptor  in function 'get_Mensaje1_Header_Repetitions'.\n");
		return -1;
	}

	if (ICD_Objs[ICD_Descriptor] == 0){
		_DBGMSG_("ERROR!. Uninitialized descriptor in function 'get_Mensaje1_Header_Repetitions'.\n");
		return -1;
	}

	
	return privates->msgInfo.header.repetitions;
}

int set_Mensaje1_Data_BlockSize_OPT(int ICD_Descriptor, unsigned int itemIndex, unsigned int value, boolean useDeserializeCopy){
	c_Mensaje1_privates_Ptr privates= 0;
	privates = &ICD_Objs[ICD_Descriptor]->mensaje1_Privates;
	
	/*printf("Set_Mensaje1-Campo1. ICD_Descriptor=%d, value=%d, useDeserializeCopy=%d\n", ICD_Descriptor, value, useDeserializeCopy);*/

	if (ICD_Descriptor<0 || ICD_Descriptor >= _MAX_ICD_INSTANCES_){
		_DBGMSG_("ERROR!. Invalid descriptor  in function 'set_Mensaje1_Data_BlockSize_OPT'.\n");
		return setterError;
	}

	if (ICD_Objs[ICD_Descriptor] == 0){
		_DBGMSG_("ERROR!. Uninitialized descriptor in function 'set_Mensaje1_Data_BlockSize_OPT'.\n");
		return setterError;
	}

	if (itemIndex>4){
		_DBGMSG_("ERROR! itemIndex out of range.");
		return setterError;
	}

	if (value>=0 && value<=65535){
		if (!useDeserializeCopy){
			privates->msgInfo.data[itemIndex].blockSize = value;
		}
		else{
			privates->msgCheckInfo.data[itemIndex].blockSize = value;
		}	
		return setterOK;
	}
	else{
		return setterError;
	}
}
			
int set_Mensaje1_Data_BlockSize(int ICD_Descriptor, unsigned int itemIndex, unsigned int value){
	int returnState = 0;
	returnState = set_Mensaje1_Data_BlockSize_OPT(ICD_Descriptor, itemIndex, value, _FALSE_);
	if (returnState==setterError){
		_DBGMSG_("ERROR! Can't assign value in function 'set_Mensaje1_Data_BlockSize'.\n");
	}

	return returnState;
}
			
int get_Mensaje1_Data_BlockSize(int ICD_Descriptor, unsigned int itemIndex){
	
	c_Mensaje1_privates_Ptr privates= 0;
	privates = &ICD_Objs[ICD_Descriptor]->mensaje1_Privates;
	
	if (ICD_Descriptor<0 || ICD_Descriptor >= _MAX_ICD_INSTANCES_){
		_DBGMSG_("ERROR!. Invalid descriptor  in function 'get_Mensaje1_Data_BlockSize'.\n");
		return -1;
	}

	if (ICD_Objs[ICD_Descriptor] == 0){
		_DBGMSG_("ERROR!. Uninitialized descriptor in function 'get_Mensaje1_Data_BlockSize'.\n");
		return -1;
	}

	if (itemIndex > 4){
		_DBGMSG_("ERROR! ItemIndex out of range in function 'get_Mensaje1_Data_BlockSize'.\n");
		return -1;
	}
	
	return privates->msgInfo.data[itemIndex].blockSize;
}


int set_Mensaje1_Data_Block(int ICD_Descriptor, unsigned int itemIndex, byte_ptr srcBuffer){
	int dataBlockSize = 0;
	c_Mensaje1_privates_Ptr privates= 0;
	
	if (ICD_Descriptor<0 || ICD_Descriptor >= _MAX_ICD_INSTANCES_){
		_DBGMSG_("ERROR!. Invalid descriptor  in function 'set_Mensaje1_Data_Block'.\n");
		return -1;
	}

	if (ICD_Objs[ICD_Descriptor] == 0){
		_DBGMSG_("ERROR!. Uninitialized descriptor in function 'set_Mensaje1_Data_Block'.\n");
		return -1;
	}

	if (itemIndex>4){
		_DBGMSG_("ERROR! itemIndex out of range in function 'set_Mensaje1_Data_Block'.");
		return -1;
	}

	privates = &ICD_Objs[ICD_Descriptor]->mensaje1_Privates;

	dataBlockSize = privates->msgInfo.data[itemIndex].blockSize;
	if (dataBlockSize>16){
		_DBGMSG_("ERROR!. daBlockSize > 16. Field 'block' Out of bound in function 'set_Mensaje1_Data_Block'!\n");
		return 0;
	}

	memcpy(privates->msgInfo.data[itemIndex].block, srcBuffer, dataBlockSize);
	return 16;
}

int get_Mensaje1_Data_Block(int ICD_Descriptor, unsigned int itemIndex, byte_ptr destBuffer){
	int dataBlockSize = 0;
	c_Mensaje1_privates_Ptr privates= 0;

	if (ICD_Descriptor<0 || ICD_Descriptor >= _MAX_ICD_INSTANCES_){
		_DBGMSG_("ERROR!. Invalid descriptor  in function 'get_Mensaje1_Data_Block'.\n");
		return -1;
	}

	if (ICD_Objs[ICD_Descriptor] == 0){
		_DBGMSG_("ERROR!. Uninitialized descriptor in function 'get_Mensaje1_Data_Block'.\n");
		return -1;
	}

	if (itemIndex>4){
		_DBGMSG_("ERROR! itemIndex out of range in function 'get_Mensaje1_Data_Block'.");
		return -1;
	}

	privates = &ICD_Objs[ICD_Descriptor]->mensaje1_Privates;

	dataBlockSize = privates->msgInfo.data[itemIndex].blockSize;

	if (dataBlockSize>16){
		_DBGMSG_("ERROR!. daBlockSize > 16. Field 'block' Out of bound in function 'get_Mensaje1_Data_Block'!\n");
		return 0;
	}

	memcpy(destBuffer, privates->msgInfo.data[itemIndex].block, dataBlockSize);
	return 16;
}


